#COMPILE EXE
'Trig Name,STATION NAME,New Name,EASTING,NORTHING,HEIGHT,ORDER,TYPE OF MARK,SECONDARY COMPUTING BLOCK,Computing Date,Maintained,CLASS OF LEVELLING,Date of Levelling,LEVELLING DATUM,DESTROYED MARK INDICATOR,COMMENTS
'Butser,PP9,PP009,471683.24,120320.824,270.997,1,PILLAR,FIG1,01/06/1936,01/09/1991,1,01/10/1957,N,0,
'Lane End Down,SU54/29,SU54S029,455047.1,126166.46,163.202,3,PILLAR,SU31,01/06/1937,01/02/1991,1,01/05/1957,N,0,

 DEFLNG a - z
FUNCTION PBMAIN () AS LONG
    COLOR 14 : PRINT "Find nearest OS Benchmarks" : PRINT
     DO
        COLOR 7
        IF COMMAND$ = "" THEN INPUT "   Base NGR            ",basengr$   ELSE basengr$ = COMMAND$
        IF basengr$ = "" THEN END
        CALL NGRtoEN(basengr$ , eb, nb)
        INPUT "   Max distance km (5) ",md!
        IF md! < .001 THEN md! = 5
        maxdist = md! * 1000
        PRINT
        INPUT "   Exclude 'Dest'[Y]/N ",dest$
        IF UCASE$(dest$) = "N" THEN ShowAll = 1
        INPUT "   Pillars only  Y/[N] ",pill$
        IF UCASE$(pill$) = "Y" THEN PillOnly% = -1

        OPEN "CompleteTrigArchive.csv" FOR INPUT AS #1
        OPEN "LocalTrigs.txt" FOR OUTPUT AS #2
        PRINT #2, "LOCAL OS BENCHMARKS"
        PRINT #2,""
        PRINT #2, USING$("Base NGR \            \  Max Distance ####.# km",basengr$,md!)
        PRINT #2, ""
        WHILE NOT EOF(1)
            LINE INPUT #1 , l$
            pcomma = 0
            commacount = 0
            DO
                pcomma = INSTR(pcomma + 1 , l$ , ",")
                IF pcomma THEN INCR commacount
                nextcomma = INSTR(pcomma + 1 , l$ , ",")
                IF nextcomma = 0 THEN nextcomma = LEN(l$)
                FieldL = nextcomma - pcomma - 1

                IF commacount = 1 THEN nam$ = MID$(l$ , 1 , pcomma - 1)        'First item no preceding comma
                IF commacount = 3 THEN e = VAL(MID$(l$ , pcomma + 1))            'Val up to next non numeric character
                IF commacount = 4 THEN n = VAL(MID$(l$ , pcomma + 1))
                IF commacount = 5 THEN h = VAL(MID$(l$ , pcomma + 1))
                IF commacount = 7 THEN typ$ = MID$(l$ , pcomma + 1, FieldL)
                IF commacount = 14 THEN info$ = MID$(l$ , pcomma + 3)
            LOOP UNTIL pcomma = 0
            CALL GenNGR(e,n,ngr$)
            dist = SQR((eb - e) ^ 2 + (nb - n) ^ 2)
            IF dist <= maxdist THEN
                IF PillOnly% AND INSTR(UCASE$(typ$) , "PILL") = 0 THEN EXIT IF
                IF INSTR(UCASE$(info$) , "DEST") > 0 AND ShowAll = 0 THEN EXIT IF
                COLOR 7
                PRINT USING$("###.# km  \                               \ \           \  ###m \            \ ",dist / 1000,nam$,ngr$,h,typ$);
                PRINT info$
                PRINT #2, USING$("###.# km  \                               \ \           \  ###m \            \ ",dist / 1000,nam$,ngr$,h,typ$);
                PRINT #2, info$
                COLOR 4
                PRINT l$

            END IF
           WEND
        CLOSE 1
        CLOSE 2
        COLOR 3
        PRINT "Results stored in ";
        PRINT "LocalTrigs.txt"
        COLOR 7

    LOOP
END FUNCTION

'...........................
SUB NGRtoEN(Ngr$, e, n)
    Ngr$ = UCASE$(Ngr$)
    DO              'First strip out any spaces
        p& = INSTR(ngr$," ")
        IF p& > 0 THEN ngr$ = LEFT$(ngr$ , p& - 1) + MID$(ngr$ , p& + 1)
    LOOP UNTIL p& = 0


    lett$ = LEFT$(ngr$, 2)
    num$ = MID$(ngr$, 3)

    le% = LEN(num$)
    IF le% >= 8 THEN
        num$ = LEFT$(num$, 3) + MID$(num$, le% / 2 + 1, 3)  'Truncate to 6 digit
    END IF


    num$ = MID$(ngr$, 3)
    le% = LEN(num$)

    PR% = le% / 2
    n = VAL(MID$(num$, PR% + 1, PR%))
    e = VAL(MID$(num$, 1, PR%))
    PR = 10 ^ (5 - PR%)                        'multiplier to get metres
    T1% = ASC(MID$(lett$, 1, 1)) - 65: IF T1% > 8 THEN T1% = T1% - 1
    T2% = ASC(MID$(lett$, 2, 1)) - 65: IF T2% > 8 THEN T2% = T2% - 1
    e = 500000 * (T1% MOD 5) + 100000 * (T2% MOD 5) - 1000000 + e * PR
    n = 1900000 - 500000 * (T1% \ 5) - 100000 * (T2% \ 5) + n * PR
END SUB
'..........................
   SUB GenNGR(e,n , ngr$)
        'convert EN to NGR


    easting1 = e \ 100000
    northing1 = n \ 100000
    C1 = 83 - 5 * (northing1 \ 5) + (easting1 \ 5)
    IF C1 = 73 THEN C1 = 72
    eh = (easting1 MOD 5)
    nh = (northing1 MOD 5)
    C2 = (4 - nh) * 5 + eh + 65
    IF C2 > 72 THEN C2 = C2 + 1
    easting2& = (e - easting1 * 100000)
    northing2& = (n - northing1 * 100000)
    CE$ = MID$(STR$(easting2&), 2)
    DO WHILE LEN(CE$) < 5
        CE$ = "0" + CE$
    LOOP
    CN$ = MID$(STR$(northing2&), 2)
    DO WHILE LEN(CN$) < 5
        CN$ = "0" + CN$
    LOOP
    ngr$ = CHR$(C1) + CHR$(C2) + CE$ + " " + CN$
END SUB
